unit frmuMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, Grids, Menus, VBScript_RegExp_55_TLB;

type
  TfrmMain = class(TForm)
    Panel1: TPanel;
    Splitter1: TSplitter;
    chbIgnoreCase: TCheckBox;
    chbMultiLine: TCheckBox;
    chbGlobal: TCheckBox;
    edPattern: TEdit;
    lblPattern: TLabel;
    sbStatus: TStatusBar;
    sgMatchResult: TStringGrid;
    btnExecute: TButton;
    btnNext: TButton;
    meString: TMemo;
    FontDialog1: TFontDialog;
    PopupMenu1: TPopupMenu;
    FontChange1: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure edPatternChange(Sender: TObject);
    procedure btnExecuteClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure chb_Click(Sender: TObject);
    procedure FontChange1Click(Sender: TObject);
    procedure meStringChange(Sender: TObject);
  private
    { Private 錾 }
    RegExp: TRegExp;
    mc: MatchCollection;
    mCnt: Integer;
    procedure ShowResult(aMatch: Boolean);
  public
    { Public 錾 }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.btnExecuteClick(Sender: TObject);
var
  Flg1: Boolean;
begin
  Enabled := False;
  try
    RegExp.IgnoreCase := chbIGnoreCase.Checked;
    RegExp.Multiline  := chbMultiLine.Checked;
    RegExp.Global     := chbGlobal.Checked;
    RegExp.Pattern    := edPattern.Text;
    mc := RegExp.Execute(meString.Lines.Text) as MatchCollection;
    Flg1 := (mc.Count > 0);
    mCnt := 0;
    btnNext.Enabled := Flg1;
    ShowResult(Flg1);
  finally
    Enabled := True;
  end;
end;

procedure TfrmMain.btnNextClick(Sender: TObject);
var
  Flg1: Boolean;
begin
  Enabled := False;
  try
    Inc(mCnt);
    Flg1 := (mCnt < mc.Count);
    btnNext.Enabled := Flg1;
    ShowResult(Flg1);
  finally
    Enabled := True;
  end;
end;

procedure TfrmMain.chb_Click(Sender: TObject);
begin
  btnNext.Enabled := False;
end;

procedure TfrmMain.edPatternChange(Sender: TObject);
begin
  btnExecute.Enabled := Length(edPattern.Text) > 0;
  btnNext.Enabled := False;
end;

procedure TfrmMain.FontChange1Click(Sender: TObject);
begin
  FontDialog1.Font.Assign(Self.Font);
  if not FontDialog1.Execute then
    Exit;
  Self.Font.Assign(FontDialog1.Font);
  sgMatchResult.DefaultRowHeight := edPattern.Height;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  FreeAndNil(RegExp);
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  OnShow := nil;
  ClientHeight := 562;
  ClientWidth  := 784;

  RegExp := TRegExp.Create(Self);
  chbIGnoreCase.Checked := RegExp.IgnoreCase;
  chbMultiLine.Checked  := RegExp.Multiline;
//chbGlobal.Checked     := RegExp.Global;
  chbGlobal.Checked     := True;

  sgMatchResult.DefaultRowHeight := edPattern.Height;
  with sgMatchResult do
    begin
      Cells[0, 0] := 'GroupIndex';
      Cells[1, 0] := 'GroupNames';
      Cells[2, 0] := 'Value';
      Cells[3, 0] := 'FirstIndex';
      Cells[4, 0] := 'Length';
    end;

  btnExecute.Enabled := False;
  btnNext.Enabled := False;
end;

procedure TfrmMain.meStringChange(Sender: TObject);
begin
  btnNext.Enabled := False;
end;

procedure TfrmMain.ShowResult(aMatch: Boolean);
var
  i: Integer;
  m: Match;
  s: ISubMatches;
begin
  if aMatch then
    begin
      sbStatus.SimpleText := 'Match';
      m := mc.Item[mCnt] as Match;
      s := m.SubMatches as ISubMatches;
      if s.Count > 0 then
        sgMatchResult.RowCount := s.Count + 2
      else
        sgMatchResult.RowCount := 2;
      sgMatchResult.Cells[0, 1] := '';
      sgMatchResult.Cells[1, 1] := '';
      sgMatchResult.Cells[2, 1] := m.Value;
      sgMatchResult.Cells[3, 1] := IntToStr(m.FirstIndex + 1);
      sgMatchResult.Cells[4, 1] := IntToStr(m.Length);
      for i:=1 to s.Count do
        begin
           sgMatchResult.Cells[0, i+1] := IntToStr(i-1);
           sgMatchResult.Cells[1, i+1] := '';
           sgMatchResult.Cells[2, i+1] := s[i-1];
           sgMatchResult.Cells[3, i+1] := '';
           sgMatchResult.Cells[4, i+1] := '';
        end;
      meString.SelStart  := m.FirstIndex;
      meString.SelLength := m.Length;
    end
  else
    begin
      sbStatus.SimpleText := 'No match';
      sgMatchResult.RowCount := 2;
      for i:=0 to sgMatchResult.ColCount-1 do
        sgMatchResult.Cells[i, 1] := '';
      meString.SelLength := 0;
      MessageBox(Handle, 'No match', 'Confirm',  MB_OK + MB_ICONINFORMATION + MB_TASKMODAL);
    end;
end;


end.
